/*
** Copyright (C) 1998,1999 Martin Roesch <roesch@clark.net>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RULES_H__
#define __RULES_H__

/*  I N C L U D E S  **********************************************************/
#include "snort.h"
#include <string.h>


/*  D E F I N E S  ************************************************************/
#define RULE_LOG   0
#define RULE_PASS  1
#define RULE_ALERT 2

#define ANY_SRC_IP     0x01
#define ANY_DST_IP     0x02
#define ANY_SRC_PORT   0x04
#define ANY_DST_PORT   0x08

/*  D A T A  S T R U C T U R E S  *********************************************/
typedef struct _Rule
{
   int type;
   u_long sip;
   u_long smask;
   u_long dip;
   u_long dmask;
   u_short sp;
   u_short dp;
   int proto;
   int pattern_match_flag;
   u_char flags;
   char *message;
   u_int pattern_size;
   char *pattern_buf;
   struct _Rule *next;
} Rule;
   

/*  P R O T O T Y P E S  ******************************************************/
void ParseRulesFile(char *);
void ParseRule(char *);
void CreateRuleNode(int);
int RuleType(char *);
int WhichProto(char *);
int  ParseIP(char *, u_long *, u_long *);
int ParsePort(char *, u_short *, char *);
void ApplyRules();
int CheckRules(Rule *);
void LogPkt();
void AlertPkt();
void DumpRuleList(Rule *);
void ParsePattern(char *rule);

#endif /* __RULES_H__ */
